> For the complete documentation index, see [llms.txt](https://docs.kiln.fi/v1/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.kiln.fi/v1/kiln-products/onchain/node-operators-how-to-integrate/pooled-staking/5.-depositing-via-integration-contracts.md).

# 5. Depositing via Integration Contracts

The last step is deploying an integration contract and connecting it to your `vPool`.

### Deploying an integration contract and connecting it

The deployment of integration contracts is covered on [this page](https://docs.kiln.fi/v1/kiln-products/onchain/node-operators-how-to-integrate/pooled-staking/7.-deploy-integration-contract-optional.md).

### Test your integration by staking 32 ETH

You should new be able to stake on your integration contract and purchase validator on your `vPool` once 32 ETH is reached&#x20;

```solidity
// 20 family stake function
function stake() external payable;

// 1155 family stake function
function stake(uint256[] calldata amounts, uint256[] calldata ids) external payable returns (bool);
```

To facilitate your usage of the integration contracts your can find the `ABIs` of the integration contracts on [this page](https://docs.kiln.fi/v1/kiln-products/onchain/node-operators-how-to-integrate/pooled-staking/7.-deploy-integration-contract-optional.md).

Once your `vPool` has accumulated 32 ETH and your oracle has reported you should be able to call :&#x20;

```solidity
function purchaseValidators(uint256 max) external;
```

This should not revert and a deposit should have happened.

Afterwards you should be able to monitor the growth of your position upon every oracle report.

<details>

<summary>TheGraph: List all funded validation keys of a vPool</summary>

```graphql
{
  vFactories(where:{address:"YOUR_FACTORY_ADDRESS"}) {
    pools {
      purchasedValidators {
        fundedValidationKey {
          validationKey {
            publicKey
          }
        }
      }
    }
  }
}
```

```json
{
  "data": {
    "vFactories": [
      {
        "pools": [
          {
            "purchasedValidators": [
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x99069f008d9807eb57fd4527af4da3fa821e19c1c382261309f7d7db3587a0f3ba28ac2b151709619034b8a18cf04d82"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xb98f2e96fb48330f0a1a1281f6bc1b97a1a8ebfa6bc3c26d69b0087bdc5395148871bf0acab5c9879fba63b61fa9e130"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xac4fa72a8acef9feb475c1225985b25f8cc4a01322f3360b5edcb9cd3a932b301dfb2a3b0cbd08344ce14f9ec7bc348e"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x89914bda9925779d73d8f44b326b5a59cd7ba6a3875f41c2f831408bb6f284f11ac0623de9051c96088193360bde7371"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xa5f1b26031df3d01c68588ae651ba687a4cb82d9724a97f693dbee6085058855e1c4c12801523e0e27cf4bf202132cd5"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x864916edaff9d6654b771bf567d7781376c78724287dca85cab1fa0083b6154350cc019530488714edab6c34111f0e48"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x85057a9a0ec28095bdf604ccfcf2ade3f8887938b05d987be8c8274021908aadab44d7dd7c214ac6ce576cd8b48b20ce"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xa0190d7ec2bcfc23decf4d5ebfde3506a052a7d7b36eb4f5bc4919cb2be59b60f9bd93ef596d16ff7c9b2c5b4c646497"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xb778163e56da5d6d0f369f51e56a394c5db60a14e9689ed021d2cb7ae464697f8b2bdafa5b02a7a146c83c0ba56736e5"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xad7eeef49245f2698a5b0cb327a6d9cad39dfc08abb29608d51d28e893e80efc95399d123a8f7761a06bbfcc363f6e86"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x809dc39429d450570ac5ba7c49da6896d6faeee01379b1ee7a5012a80f2098a17e2bceb5e2f97fff07a53e26270506a4"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x99f34e91679d475612fd7b52685e18c8504fee5e7102bc5b1b5a2d30a8c05223f07ffe74ce17f984f9d17463b18e5000"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xa47a3d7b68d4b85e71cff5496eb8740b5a43a756da00dcbe7e1186e1461b33b233710c5fa11c91b7ffb774467977d02f"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x8c1ccedbfc5a13668a4acf561b9bc813bee2610a7a07847c09281b503122d684a13d00d7ab9a606dab20b57bfb0a3371"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xa43bf6f7191086e47d7c71b9e1acfc14a7921d43ba0134141605f744dd582b672b9e6e4e30c74b541735754533d05618"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xa15308fd5cd254eb8e890532552328cc43bcabc1d0dca20f68b6956a3974d84ab2d920eba3418a8246a0e791f8ec3983"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xac95f5c11153eec413e687e03d61c3cc80ceaf1431434022a69cdd50b9147a2676a5d37665c08e0e446323273edb2f9c"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0xaabecd1bf61c763503487ee49f4a30bb1402abd57ca99d586492cd336830f502b4279f8b9e9abebdf90b1aa126720833"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x99724d63e63691ab525adb61f20329ebcf302da31e200c43054b2b96cf004ddc661847a4abcdc38c26acd87921181463"
                  }
                }
              },
              {
                "fundedValidationKey": {
                  "validationKey": {
                    "publicKey": "0x92bb6f206db5f0eb334a7cffe1abec7177e971bf626de1e11921d7759f1cf8151bd4ab6f3502449c2e92436828f25448"
                  }
                }
              }
            ]
          }
        ]
      }
    ]
  }
}
```

</details>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.kiln.fi/v1/kiln-products/onchain/node-operators-how-to-integrate/pooled-staking/5.-depositing-via-integration-contracts.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
